<?php
namespace PME\Controllers\Custo;

use Zeedhi\Framework\Report\ReportService;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DB\StoredProcedure\StoredProcedure;
use Zeedhi\Framework\DB\StoredProcedure\Param;
use Zeedhi\Framework\DataSource\DataSet;

class CustoPlanejadoCardapioController extends \Zeedhi\Framework\Controller\Report {
  protected $entityManager;
  protected $birtStrategy;
  protected $newCode;
  protected $connection;
  protected $utilities;
  protected $lista;
  protected $crudService;
  protected $CustoPlanejadoRealizadoController;

  public function __construct(ReportService $reportService, $entityManager, $birtStrategy, $newCode, $connection, $utilities, $lista, $crudService, $CustoPlanejadoRealizadoController) {
    $this->entityManager = $entityManager;
    $this->birtStrategy  = $birtStrategy;
    $this->newCode       = $newCode;
    $this->connection    = $connection;
    $this->utilities     = $utilities;
    $this->lista         = $lista;
    $this->crudService   = $crudService;
    $this->CustoPlanejadoRealizadoController = $CustoPlanejadoRealizadoController;
    
    parent::__construct($reportService);
  }

  protected $reportMapping = array (
    'PME08000' => 
    array (
      'strategy' => 'BIRT',
      'parameterMapping' => 
      array (
        "CDTIPOCUSTO"  => "P_NRTIPOCUSTO",
        "DTDE"         => "P_DTINICIAL",
        "DTATE"        => "P_DTFINAL",
        "NMTIPOCUSTO"  => "P_NMCUSTO",
        "CDFILCENTPME" => "P_CDFILCENTPME",
        "NRLISTATPCARD" => "P_NRLISTATPCARD",
        "UNIDADE"      => "P_CDFILIAL",
        "NRLISTASERVICO"   => "P_NRLISTASERVICO",
        "NRCONSPLAN"   => "P_NRCONSPLAN",
        "CDPICTPROD"   => "P_CDPICTPROD",
        "ORDENA"       => "P_ORDENA",
        "NRORG"        => "P_NRORG"
      )
    ),
    'PME08001' => 
    array (
      'strategy' => 'BIRT',
      'parameterMapping' =>
      array (
        "CDTIPOCUSTO"  => "P_NRTIPOCUSTO",
        "DTDE"         => "P_DTINICIAL",
        "DTATE"        => "P_DTFINAL",
        "NMTIPOCUSTO"  => "P_NMCUSTO",
        "UNIDADE"      => "P_CDFILIAL",
        "NRLISTASERVICO"   => "P_NRLISTASERVICO",
        "CDFILCENTPME" => "P_CDFILCENTPME",
        "NRLISTATPCARD"   => "P_NRLISTATPCARD",
        "NRCONSPLAN"   => "P_NRCONSPLAN",
        "CDPICTPROD"   => "P_CDPICTPROD",
        "ORDENA"       => "P_ORDENA",
        "NRORG"        => "P_NRORG"
      )
    ),
    'PME08002' => 
    array (
      'strategy' => 'BIRT',
      'parameterMapping' =>
      array (
        "CDTIPOCUSTO"  => "P_NRTIPOCUSTO",
        "DTDE"         => "P_DTINICIAL",
        "DTATE"        => "P_DTFINAL",
        "NMTIPOCUSTO"  => "P_NMCUSTO",
        "CDFILCENTPME" => "P_CDFILCENTPME",
        "NRLISTATPCARD"   => "P_NRLISTATPCARD",
        "UNIDADE"      => "P_CDFILIAL",
        "NRLISTASERVICO"   => "P_NRLISTASERVICO",
        "NRCONSPLAN"   => "P_NRCONSPLAN",
        "NRORG"        => "P_NRORG"
      )
    ),
    'PME08003' => 
    array (
      'strategy' => 'BIRT',
      'parameterMapping' =>
      array (
        "CDTIPOCUSTO"  => "P_NRTIPOCUSTO",
        "DTDE"         => "P_DTINICIAL",
        "DTATE"        => "P_DTFINAL",
        "NMTIPOCUSTO"  => "P_NMCUSTO",
        "CDFILCENTPME" => "P_CDFILCENTPME",
        "NRLISTATPCARD"   => "P_NRLISTATPCARD",
        "UNIDADE"      => "P_CDFILIAL",
        "NRLISTASERVICO"   => "P_NRLISTASERVICO",
        "NRCONSPLAN"   => "P_NRCONSPLAN",
        "ORDENA"       => "P_ORDENA",
        "NRORG"        => "P_NRORG"
      )
    ),
    'PME08004' => 
    array (
      'strategy' => 'BIRT',
      'parameterMapping' =>
      array (
        "CDTIPOCUSTO"  => "P_NRTIPOCUSTO",
        "DTDE"         => "P_DTINICIAL",
        "DTATE"        => "P_DTFINAL",
        "NMTIPOCUSTO"  => "P_NMCUSTO",
        "CDFILCENTPME" => "P_CDFILCENTPME",
        "NRLISTATPCARD"   => "P_NRLISTATPCARD",
        "UNIDADE"      => "P_CDFILIAL",
        "NRLISTASERVICO"   => "P_NRLISTASERVICO",
        "NRCONSPLAN"   => "P_NRCONSPLAN",
        "CDPICTPROD"   => "P_CDPICTPROD",
        "ORDENA"       => "P_ORDENA",
        "NRORG"        => "P_NRORG"
      )
    ),
    'PME08005' => 
    array (
      'strategy' => 'BIRT',
      'parameterMapping' =>
      array (
        "CDTIPOCUSTO"  => "P_NRTIPOCUSTO",
        "DTDE"         => "P_DTINICIAL",
        "DTATE"        => "P_DTFINAL",
        "NMTIPOCUSTO"  => "P_NMCUSTO",
        "CDFILCENTPME" => "P_CDFILCENTPME",
        "NRLISTATPCARD"   => "P_NRLISTATPCARD",
        "UNIDADE"      => "P_CDFILIAL",
        "NRLISTASERVICO"   => "P_NRLISTASERVICO",
        "NRCONSPLAN"   => "P_NRCONSPLAN",
        "NRORG"        => "P_NRORG"
        
      )
    ),
    'PME08006' => 
    array (
      'strategy' => 'BIRT',
      'parameterMapping' =>
      array (
        "CDFILCENTPME" => "P_CDFILCENTPME",
        "CDTIPOCUSTO"  => "P_NRTIPOCUSTO",
        "DTDE"         => "P_DTINICIAL",
        "DTATE"        => "P_DTFINAL",
        "NMTIPOCUSTO"  => "P_NMCUSTO",
        "NRLISTATPCARD"   => "P_NRLISTATPCARD",
        "UNIDADE"      => "P_CDFILIAL",
        "NRLISTASERVICO"   => "P_NRLISTASERVICO",
        "NRCONSPLAN"   => "P_NRCONSPLAN",
        "NRORG"        => "P_NRORG"
        
      )
    ),
    'PME08007' => 
    array (
      'strategy' => 'BIRT',
      'parameterMapping' =>
      array (
        "CDTIPOCUSTO"  => "P_NRTIPOCUSTO",
        "DTDE"         => "P_DTINICIAL",
        "DTATE"        => "P_DTFINAL",
        "NMTIPOCUSTO"  => "P_NMCUSTO",
        "CDFILCENTPME" => "P_CDFILCENTPME",
        "NRLISTATPCARD"   => "P_NRLISTATPCARD",
        "UNIDADE"      => "P_CDFILIAL",
        "NRLISTASERVICO"   => "P_NRLISTASERVICO",
        "NRCONSPLAN"   => "P_NRCONSPLAN",
        "NRORG"        => "P_NRORG"
      )
    ),
    'PME08008' => 
    array (
      'strategy' => 'BIRT',
      'parameterMapping' =>
      array (
        "CDFILCENTPME" => "P_CDFILCENTPME",
        "CDTIPOCUSTO"  => "P_NRTIPOCUSTO",
        "DTDE"         => "P_DTINICIAL",
        "DTATE"        => "P_DTFINAL",
        "NMTIPOCUSTO"  => "P_NMCUSTO",
        "NRLISTATPCARD"   => "P_NRLISTATPCARD",
        "UNIDADE"      => "P_CDFILIAL",
        "NRLISTASERVICO"   => "P_NRLISTASERVICO",
        "NRCONSPLAN"   => "P_NRCONSPLAN",
        "NRORG"        => "P_NRORG"
        
      )
    ),
    'PME08009' => 
    array (
      'strategy' => 'BIRT',
      'parameterMapping' =>
      array (
        "CDFILCENTPME" => "P_CDFILCENTPME",
        "DTDE"         => "P_DTINICIAL",
        "DTATE"        => "P_DTFINAL",
        "NMTIPOCUSTO"  => "P_NMCUSTO",
        "NRCONSPLAN"   => "P_NRCONSPLAN",
        "CDTIPOCUSTO"  => "P_NRTIPOCUSTO",
        "CDPICTPRAT"   => "P_CDPICTPRAT",
        "CDPICTPROD"   => "P_CDPICTPROD",
        "ORDENA"       => "P_ORDENA",
        "NRORG"        => "P_NRORG"
      )
    ),
    'PME0800A' => 
    array (
      'strategy' => 'BIRT',
      'parameterMapping' =>
      array (
        "DTDE"         => "P_DTINICIAL",
        "DTATE"        => "P_DTFINAL",
        "NMTIPOCUSTO"  => "P_NMCUSTO",
        "NRCONSPLAN"   => "P_NRCONSPLAN",
        "CDFILCENTPME" => "P_CDFILCENTPME",
        "CDTIPOCUSTO"  => "P_NRTIPOCUSTO",
        "CDPICTPROD"   => "P_CDPICTPROD",
        "CDPICTPRAT"   => "P_CDPICTPRAT",
        "ORDENA"       => "P_ORDENA",
        "NRORG"        => "P_NRORG"
      )
    )
  );
    
  public function beforeProcessReport(DTO\Request\Row $request, DTO\Response $response) {
    $row = $request->getRow();
    $nrorg = $this->utilities->getNrOrg();
    $row['NRORG'] = $nrorg;

    if(empty($row['NUTRICIONISTA']) && empty($row['UNIDADE'])) $unidade = $this->getUnidades($row); 
    else {
      if (empty($row['UNIDADE'])) $unidade = $this->getUnidades($row);
      else $unidade = is_array($row['UNIDADE']) ? join("_", $row['UNIDADE']) : $row['UNIDADE'];
    }
  
    $cardapios = [];
    if(empty($row['TIPOCARD'])) {
      $tipoCard = $this->getCardapio($row, $nrorg);
      
      foreach($tipoCard as $card) {
        array_push($cardapios, $card['CDTIPOCARD']);
      }
      $tipoCard = join("_", $cardapios);
    } else {
      if (is_array($row['TIPOCARD'])) {
        foreach($row['TIPOCARD'] as $card){
          array_push($cardapios, $card['CDTIPOCARD']);
        }
        $tipoCard = join("_", $cardapios);
      }
    }
    
    if(empty($row['SERVICO'])) {
      $servicoConcat = [];
      $servico = $this->getServicos($row, $tipoCard, $nrorg);
      foreach($servico as $serv) {
        array_push($servicoConcat, $serv['CDSERVFILI']);
      }
      $servico = join("_", $servicoConcat);
    }
    else {
      $servicos = [];
      if (is_array($row['CDSERVFILI'])) {
        foreach($row['CDSERVFILI'] as $serv){
          array_push($servicos, $serv['CDSERVFILI']);
        }
        
        $servico = join("_", $servicos);
      }
    }
    
    if(empty($row['TIPOCARD'])) $tipoCardLista = $this->getCardapio($row, $nrorg);
    else $tipoCardLista = $row['TIPOCARD'];
    $tipoCardLista = $this->geraListaTipoCard($tipoCardLista, $nrorg, $row['CDFILCENTPME']);
    
    if(empty($row['SERVICO'])) $servicoLista = $this->getServicos($row, $tipoCard, $nrorg);
    else $servicoLista = $row['CDSERVFILI'];
    $servicoLista = $this->geraListaServico($servicoLista, $nrorg, $row['CDFILCENTPME'], $tipoCard, $unidade, $servico);

    $row['UNIDADE'] = $unidade;
    $row['CDFILIAL'] = $unidade;
    $row['TIPOCUSTO'] = $row['TIPOCUSTO']['CDTIPOCUSTO'];
    $row['CDSERVFILI'] = $servico;
    $row['CDTIPOCARD'] = $tipoCard;
    $this->procedure($row);
    
    $row['NRLISTASERVICO'] = $servicoLista;
    $row['NRLISTATPCARD'] = $tipoCardLista;

    $this->birtStrategy->setReportLocale($this->utilities->getLanguage());
    $this->birtStrategy->setReportFormat(strtolower($row['reportFormat']));
  }
    
  public function geraListaTipoCard($rows, $nrorg, $cdfilcentpme) {
    $nrlista = $this->newCode->getCodeByTableName('LISTA_TIPOCARD', $nrorg);
    $sql = "INSERT INTO LISTA_TIPOCARD (NRLISTA, CDFILCENTPME, CDTIPOCARD, NMTIPOCARD, NRORG) VALUES (:NRLISTA, :CDFILCENTPME, :CDTIPOCARD, :NMTIPOCARD, :NRORG)";

    foreach ($rows as $card) {
      $stmt = $this->entityManager->getConnection()->prepare($sql);
      $stmt->execute(
        array(
          "NRLISTA"      => $nrlista,
          "CDFILCENTPME" => $cdfilcentpme,
          "CDTIPOCARD"   => $card['CDTIPOCARD'],
          "NMTIPOCARD"   => $card['NMTIPOCARD'],
          "NRORG"        => $nrorg
        )
      );
    }
    return $nrlista;
  }
  
  public function geraListaServico($servicoLista, $nrorg, $cdfilcentpme, $tipoCard, $unidade, $servicoConcat) {
    $nrlista = $this->newCode->getCodeByTableName('LISTA_SERVICO', $nrorg);
    
    $sql = "INSERT INTO LISTA_SERVICO (NRLISTA, CDFILIAL, CDSERVFILI, NMSERVICO, CDGRUPSERV, NRORG) VALUES (:NRLISTA, :CDFILIAL, :CDSERVFILI, :NMSERVICO, :CDGRUPSERV, :NRORG)";
    $sqlAgreg = "SELECT DISTINCT SERVICO.CDGRUPSERV, SERVICO.NMSERVICO, SERVICO.CDSERVFILI, SERVICO.CDFILIAL, SERVICO.NRORG FROM SERVTIPOCARD, SERVICO WHERE SERVTIPOCARD.CDFILCENTPME = :CDFILCENTPME AND ( INSTR(:CDTIPOCARD, SERVTIPOCARD.CDTIPOCARD) <> 0 OR ( :CDTIPOCARD = 'T' ) ) AND SERVTIPOCARD.CDSERVFILI = SERVICO.CDSERVFILI AND ( INSTR(:CDFILIAL, SERVICO.CDFILIAL) <> 0 OR ( :CDFILIAL = 'T' ) ) AND ( INSTR(:CDSERVFILI, SERVICO.CDSERVFILI) <> 0 OR ( :CDSERVFILI = 'T' ) ) AND SERVICO.IDTIPOSERV = 'M' ORDER BY SERVICO.CDSERVFILI, SERVICO.CDFILIAL";
    
    $params = array(
      "CDTIPOCARD"   => $tipoCard,
      "CDFILCENTPME" => $cdfilcentpme,
      "CDFILIAL"     => $unidade,
      "CDSERVFILI"   => $servicoConcat
    );
    
    $stmtCard = $this->connection->prepare($sqlAgreg);
	  $stmtCard->execute($params);
    $result = $stmtCard->fetchAll();
    
    foreach ($result as $pos) {
      $stmt = $this->entityManager->getConnection()->prepare($sql);
      $stmt->execute(
        array(
          "NRLISTA"    => $nrlista,
          "CDFILIAL"   => $pos['CDFILIAL'],
          "NRORG"      => $nrorg,
          "CDSERVFILI" => $pos['CDSERVFILI'],
          "NMSERVICO"  => $pos['NMSERVICO'],
          "CDGRUPSERV" => $pos['CDGRUPSERV'],
        )
      );
    }
    return $nrlista;
  }
    
  private function procedure($row){
    if (($row['CD_REPORT_CODE'] === 'PME08009') || ($row['CD_REPORT_CODE'] === 'PME0800A')) $idseprato = 'P';
    else $idseprato = 'N';

    $row['NRCONSPLAN'] = $this->utilities->consumoPlanPMe($row['CDFILCENTPME'], $row['CDTIPOCARD'], $row['UNIDADE'], $row['CDSERVFILI'], $row['DTDE'], $row['DTATE'], 'A', 'CFP', $idseprato);
  }
    
  private function getUnidades($row){
    $unidades = [];
    $nutricio = empty($row['NUTRICIONISTA']) ? 'T' : implode('_', $row['NUTRICIONISTA']);

    $query = "SELECT DISTINCT F.NRORG, F.CDFILIAL, F.NMFILIAL FROM FILIAL F, (SELECT N.CDFILIAL FROM NUTRICIO N, OPERADOR O, FILIOPER F, (SELECT CDFILIAL FROM FILIAL WHERE CDFILCENTPME = :P_CDFILCENTPME AND IDFILCENTPME = 'N') FI WHERE N.CDNUTRICIO = O.CDOPERADOR AND O.CDOPERADOR = F.CDOPERADOR AND N.CDFILIAL = F.CDFILIAL AND FI.CDFILIAL = F.CDFILIAL AND (INSTR(:P_CDNUTRICIO, N.CDNUTRICIO) > 0 OR (:P_CDNUTRICIO = 'T'))) N WHERE F.CDFILCENTPME = :P_CDFILCENTPME AND F.IDFILCENTPME = 'N' AND F.CDFILIAL = N.CDFILIAL ORDER BY F.CDFILIAL";
    $params = array(
      "P_CDFILCENTPME" => $row["CDFILCENTPME"],
      "P_CDNUTRICIO"   => $nutricio
    );
    $stmt = $this->connection->prepare($query);
	  $stmt->execute($params);
    $result = $stmt->fetchAll();

    foreach($result as $unid){
      array_push($unidades, $unid['CDFILIAL']);
    }
    $resultado = join("_", $unidades);
    return $resultado;
  }
    
  public function getServicos($row, $tipoCard, $nrorg) {
	    $dataSourceName = 'servicoPorTpCardapioSelectMultiplo';
	    $conditions = array(
	        array(
	            'columnName' => 'NRORG',
	            'operator' => '=',
	            'value' => $nrorg
	        ),
	        array(
	            'columnName' => 'CDFILCENTPME',
	            'operator' => '=',
	            'value' => $row["CDFILCENTPME"]
	        ),
	        array(
	            'columnName' => 'CDTIPOCARD',
	            'operator' => '=',
	            'value' => $tipoCard
	        )
	    );	    
	    $result = $this->crudService->getFilteredDataSet($dataSourceName, $conditions)->getRows();
	    return $result;
	}
  
  public function getCardapio($row, $nrorg) {
	    $dataSourceName = 'tpCardapioPorCentral';
	    $conditions = array(
	        array(
	            'columnName' => 'NRORG',
	            'operator' => '=',
	            'value' => $nrorg
	        ),
	        array(
	            'columnName' => 'CDFILCENTPME',
	            'operator' => '=',
	            'value' => $row["CDFILCENTPME"]
	        ),
	        array(
	            'columnName' => 'NRPASTATCARD',
	            'operator' => '=',
	            'value' => NULL
	        )
	    );	    
	    $result = $this->crudService->getFilteredDataSet($dataSourceName, $conditions)->getRows();
	    return $result;
	}
}